<cfcomponent output="false">

	<cffunction name="execute" access="public" output="false" returntype="boolean">
		<cfargument name="attributes" required="true"/>
		<cfset var local = structNew() />
		<cfset local.customerGateway = createObject("component","model.customerGateway") />
		<!--- logged in and has challenge question --->
		<cfif isLoggedIn() AND val( arguments.customerGW.getByID( val(client.customerID ) ).getChallengeQuestionID() ) GT 0>
			<cfset local.result = "true" />
		<!--- challenge Info Submitted --->
		<cfelseif structKeyExists( arguments.attributes, "regChallengeAnswer") AND structKeyExists( arguments.attributes, "regChallengeQuestionID")  >
			<!--- validate challenge info --->
			<cfif isValidChallengeInfo( arguments.attributes ) >
				<!--- save challenge answer --->
				<cfset local.cust =  arguments.customerGW.getById( client.customerID ) /> />
				<cfset local.cust.setChallengeQuestionID( attributes.regChallengeQuestionID ) />
				<cfset local.cust.setChallengeAnswer( attributes.regChallengeAnswer ) />
				<cfset arguments.customerGW.save( cust ) />
				<cfset local.result = "true" />
			<cfelse>
				<!--- Deal with invalid data --->
				<cfset local.result = "false" /><!--- this seems unnecessary --->
				<cfset attributes.userMessage= "Please select a security question and provide an answer." />
			</cfif>	
		<cfelse>	
			<!--- this seems unnecessary --->
			<cfset local.result = "false" />
		</cfif>		
		<cfreturn local.result />
	</cffunction>
	
	<cffunction name="isLoggedIn" output="false" access="private" returntype="boolean">
		<cfset var rtn = false />
		<cfif structKeyExists( client, "customerID" ) AND val( client.customerID ) GT 0 >
			<cfset rtn = true />
		</cfif>		
		<cfreturn rtn />			
	</cffunction>
		
	<cffunction name="isValidChallengeInfo" output="false" access="private" returntype="boolean">
		<cfargument name="attributes" type="struct" required="true"/>
		<cfset var rtn = false />
		<cfif validateChallengeQuestion( arguments.attributes ) AND validateChallengeAnswer( arguments.attributes ) >
			<cfset rtn = true />
		</cfif>		
		<cfreturn rtn />	
	</cffunction>
		
	<cffunction name="validateChallengeQuestion" output="false" access="private" returntype="boolean">
		<cfargument name="attributes" type="struct" required="true"/>
		<cfset var rtn = false />
		<cfif structKeyExists( arguments.attributes, "regChallengeQuestionID") AND val( attributes.regChallengeQuestionID ) GT 0 >
			<cfset rtn = true />
		</cfif>		
		<cfreturn rtn />	
	</cffunction>
	
	<cffunction name="validateChallengeAnswer" output="false" access="private" returntype="boolean">
		<cfargument name="attributes" type="struct" required="true"/>
		<cfset var rtn = false />
		<cfif structKeyExists( arguments.attributes, "regChallengeAnswer") AND len( trim( attributes.regChallengeAnswer ) ) GT 0 >
			<cfset rtn = true />
		</cfif>		
		<cfreturn rtn />
	</cffunction>
	
</cfcomponent>