<cffunction name="onError" output="true">
   <cfargument name="exception" required="true"/>
   <cfargument name="eventName" required="true"/>
      <!--- Exit conditions --->
      <cfif arguments.Exception.RootCause.Type IS "coldfusion.runtime.AbortException">
         <cfreturn />
      </cfif>
      <cfif trim(arguments.eventName) IS "onSessionEnd">
         <cfreturn />
      </cfif>
      <!--- Log and Exit --->
      <cfif trim(arguments.eventName) IS "onApplicationEnd">
         <cflog file="#this.name#" type="Information" text="Application #this.name# ended."/>
         <cflog file="#this.name#" type="error" text="Event name: #arguments.eventName#"/>
         <cflog file="#this.name#" type="error" text="Message: #arguments.exception.message#"/>
         <cfreturn />
      </cfif>
      <!--- use error template file or print to screen --->
      <cfoutput>
         <cfif isDebugMode() IS false>
            <cfinclude template="/errortemplate.htm"/>
         <cfelse>
            <h2>An unexpected error has occurred.</h2>
            <p>Error event: #arguments.eventName#</p>
            <p>Error details:</p>
            <cfdump var="#arguments.exception#"/>
         </cfif>
         <cflog file="#this.name#" type="error" text="Event name: #arguments.eventName#"/>
         <cflog file="#this.name#" type="error" text="Message: #arguments.exception.message#"/>
      </cfoutput>
</cffunction>